## qt5-quickcontrols-nemo-5.7.2-2.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.0)

project(qtquickcontrols-nemo
        VERSION 5.7.0
	DESCRIPTION "QtQuick.Controls.Nemo")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

include(FeatureSummary)
include(GNUInstallDirs)

set(INSTALL_QML_IMPORT_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/qt/qml"
	CACHE PATH "Custom QML import installation directory")

set(QT_MIN_VERSION "5.11.0")
find_package(Qt5 ${QT_MIN_VERSION} COMPONENTS Gui Qml Quick REQUIRED)
find_package(Qt5QuickCompiler)
find_package(PkgConfig REQUIRED)

### Sets QT_INSTALL_QML to the directory where QML Plugins should be installed
function(FindQtInstallQml)
    find_program(QMAKE NAMES qmake-qt5 qmake)
    if(NOT QMAKE)
        message(FATAL_ERROR "qmake not found")
    endif()
    execute_process(
        COMMAND ${QMAKE} -query QT_INSTALL_QML
        OUTPUT_VARIABLE PROC_RESULT
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(QT_INSTALL_QML ${PROC_RESULT} PARENT_SCOPE)
endfunction()

FindQtInstallQml()

add_subdirectory(examples)
add_subdirectory(src)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
add_subdirectory(sizeview)
add_subdirectory(touch)

=== src/CMakeLists.txt ===
add_subdirectory(controls)
add_subdirectory(models)
add_subdirectory(styles)

=== examples/sizeview/CMakeLists.txt ===
find_package(Glacier 0.8 COMPONENTS App REQUIRED)

set(SRC
	main.cpp
)

qtquick_compiler_add_resources(RESOURCES glacier-sizeview.qrc)

add_executable(glacier-sizeview ${SRC} ${RESOURCES})

target_link_libraries(glacier-sizeview
	Qt5::Gui
	Qt5::Qml
	Qt5::Quick
	Glacier::App
)

install(TARGETS glacier-sizeview RUNTIME
	DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/touch/CMakeLists.txt ===
find_package(Glacier 0.8 COMPONENTS App REQUIRED)

set(SRC
	src/main.cpp
)

qtquick_compiler_add_resources(RESOURCES glacier-components.qrc)

add_executable(glacier-components ${SRC} ${RESOURCES})

target_link_libraries(glacier-components
	Qt5::Gui
	Qt5::Qml
	Qt5::Quick
	Glacier::App
)

install(TARGETS glacier-components RUNTIME
	DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES org.nemomobile.notify.service
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

install(FILES glacier-components.desktop
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

=== src/controls/CMakeLists.txt ===
pkg_check_modules(MLITE mlite5 REQUIRED IMPORTED_TARGET)

set(SRC
    ringindicator.cpp
    qquickfilteringmousearea.cpp
    sizing.cpp
    nemopage.cpp
    qrc_internal_resources.cpp
    nemoimageprovider.cpp
    qquicknemocontrolsextensionplugin.cpp
    themedaemon/mlocalthemedaemonclient.cpp
    themedaemon/mabstractthemedaemonclient.cpp
    editfilter.cpp
    theme.cpp
    nemofocussingleton.cpp
    nemowindow.cpp
)

set(HEADERS
    editfilter.h
    theme.h
    ringindicator.h
    nemoimageprovider.h
    qquicknemocontrolsextensionplugin.h
    themedaemon/mlocalthemedaemonclient.h
    themedaemon/mabstractthemedaemonclient.h
    qquickfilteringmousearea.h
    nemofocussingleton.h
    nemowindow.h
    sizing.h
    nemopage.h
)

add_library(nemocontrolsplugin SHARED ${SRC} ${MLITE})

target_link_libraries(nemocontrolsplugin
    Qt5::Core
    Qt5::Qml 
    Qt5::Quick
    PkgConfig::MLITE)

install(DIRECTORY qml DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Nemo/)
install(TARGETS nemocontrolsplugin DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Nemo/)

install(DIRECTORY qml/
        DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Nemo/
        PATTERN "dialogs" EXCLUDE)
        
install(DIRECTORY qml/dialogs/
        DESTINATION ${QT_INSTALL_QML}/Nemo/Dialogs)

install(DIRECTORY images
        DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Nemo)

=== src/models/CMakeLists.txt ===

set(SRC
    calendarmodel.cpp
    plugin.cpp)

set(HEADERS
    calendarmodel.h)

add_library(nemouxmodels SHARED ${SRC})

target_link_libraries(nemouxmodels
    Qt5::Core
    Qt5::Qml 
    Qt5::Quick)

install(FILES qmldir DESTINATION ${QT_INSTALL_QML}/Nemo/UX/Models/)
install(TARGETS nemouxmodels DESTINATION ${QT_INSTALL_QML}/Nemo/UX/Models/)

=== src/styles/CMakeLists.txt ===
set(SRC
    qquicknemostyleextensionplugin.cpp
)

set(HEADERS
    qquicknemostyleextensionplugin.h
)

add_library(nemostyleplugin SHARED ${SRC})

target_link_libraries(nemostyleplugin
    Qt5::Core
    Qt5::Qml 
    Qt5::Quick
)

install(TARGETS nemostyleplugin DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Styles/Nemo/)

install(DIRECTORY qml/
        DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Styles/Nemo/)

install(DIRECTORY images
        DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Styles/Nemo/)

install(DIRECTORY themes
        DESTINATION ${QT_INSTALL_QML}/QtQuick/Controls/Styles/Nemo/)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=qt5-quickcontrols-nemo
pkgver=5.7.2
pkgrel=2
pkgdesc="QML components for Nemomobile, based on QtQuickControls"
arch=('x86_64')
url="https://github.com/nemomobile-ux/qtquickcontrols-nemo"
license=('LGPL' 'Apache')
depends=('libglacierapp' 'nemo-qml-plugin-configuration' 'nemo-qml-plugin-notifications'
         'nemo-theme-glacier' 'qt5-graphicaleffects' 'qt5-quickcontrols' 'qt5-virtualkeyboard')
makedepends=('cmake')
source=("https://github.com/nemomobile-ux/qtquickcontrols-nemo/archive/$pkgver/$pkgname-$pkgver.tar.gz")
sha512sums=('317fed85dbedc9e1120f7d51bd8dcda3f234ea7069f27eb9f999cfadd991f09f19879cb03363cdd5109a846c9e890385587e4118b2d647bb9d689fbbcd1bf265')

build() {
  cd qtquickcontrols-nemo-$pkgver
  cmake . -DCMAKE_INSTALL_PREFIX=/usr
  make
}

package() {
  cd qtquickcontrols-nemo-$pkgver
  make DESTDIR="$pkgdir" install
}
